﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlanetChildCollisionScript : MonoBehaviour {


	// Use this for initialization
	void Start () {
    }
	
	// Update is called once per frame
	void Update () {
	}

    private void OnTriggerStay2D(Collider2D collision)
    {
        GameObject playerShip = collision.gameObject;
        GameObject planetTarget = GetComponent<Collider2D>().gameObject;

        //Debug.Log(playerShip.name + " -> " + planetTarget.name);

        switch (planetTarget.name)
        {
            case "PlanetCollider":
                PlayerControllerScript playerController = (PlayerControllerScript)playerShip.GetComponent<PlayerControllerScript>();
                Debug.Log("death!");
                playerController.DeadlyExplosion();
                break;
            case "InnerGravityCollider":
                ApplyGravityToParent(playerShip, planetTarget);
                break;
            case "OuterGravityCollider":
                ApplyGravityToParent(playerShip, planetTarget);
                break;
            default:
                break;
        }
    }

    //private void OnTriggerEnter2D(Collider2D collision)
    //{
    //    //Debug.Log(GetComponent<Collider2D>().gameObject.name + " -> " + collision.gameObject.name);

    //    GameObject playerShip = collision.gameObject;
    //    GameObject planetTarget = GetComponent<Collider2D>().gameObject;

    //    //Debug.Log(playerShip.name + " -> " + planetTarget.name);

    //    switch (planetTarget.name)
    //    {
    //        case "PlanetCollider":
    //            PlayerControllerScript playerController = (PlayerControllerScript)playerShip.GetComponent<PlayerControllerScript>();
    //            Debug.Log("death!");
    //            playerController.DeadlyExplosion();
    //            break;
    //        case "InnerGravityCollider":
    //            ApplyGravityToParent(playerShip, planetTarget);
    //            break;
    //        case "OuterGravityCollider":
    //            ApplyGravityToParent(playerShip, planetTarget);
    //            break;
    //        default:
    //            break;
    //    }
        
    //}

    private void ApplyGravityToParent(GameObject playerShip, GameObject planetTarget)
    {
        //Debug.Log(playerShip.name + " -> " + planetTarget.name);

        /*
        playerShip.GetComponent<Rigidbody2D>().AddForce(new Vector3(10, planetTarget.transform.up.y), ForceMode2D.Force);

        Vector2 v = playerShip.GetComponent<Rigidbody2D>().velocity;
        float angle = Mathf.Atan2(v.y, v.x) * Mathf.Rad2Deg;
        transform.rotation = Quaternion.AngleAxis(angle, Vector3.forward);
        */

        //Vector3 shipRot = playerShip.transform.up;
        //Vector3 shipPos = playerShip.transform.position;
        //Vector3 planetCenter = planetTarget.transform.position;

        //float dirToPlanet = (planetCenter.x - shipPos.x) / (planetCenter.y - shipPos.y);

        //playerShip.transform.rotation = Quaternion.Euler (Vector3.Cross(shipPos, planetCenter));

        //Debug.Log("Ship rot: " + shipRot);
        //Debug.Log("Ship pos: " + shipPos);
        //Debug.Log("Planet pos: " + planetCenter);

        var heading = planetTarget.transform.position - playerShip.transform.position;
        var distance = heading.magnitude;
        var direction = heading / distance;
        playerShip.GetComponent<Rigidbody2D>().AddForce(direction * 100f * Time.deltaTime);

    }

}
