﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlanetScript : MonoBehaviour {

	// Use this for initialization
	void Start () {
        
    }
	
	// Update is called once per frame
	void Update () {
        animateGravityRing();
	}

    private void Awake()
    {
        
    }

    private void animateGravityRing()
    {
        GameObject gravWave = gameObject.transform.FindChild("OuterGravityCollider").gameObject.transform.FindChild("GravWave2").gameObject;
        SpriteRenderer gravSprite = gravWave.GetComponent<SpriteRenderer>();

        if (gravWave.transform.localScale.x <= 1)
        {
            gravWave.transform.localScale = new Vector3(3f, 3f, 3f);
            gravSprite.color = new Color(1f, 1f, 1f, 0f);
        }
        else
        {
            gravWave.transform.localScale = Vector3.MoveTowards(gravWave.transform.localScale, new Vector3(0.5f, 0.5f, 0.5f), .05f);

            Vector3 gravScaleDiff = new Vector3(3f, 3f, 3f) - gravWave.transform.localScale;
            gravSprite.color = new Vector4(1f, 1f, 1f, gravScaleDiff.x);
            //gravSprite.color = gravSprite.color - new Color(0f, 0f, 0f, .025f);
        }

        
    }

}
